////////////////////////////////////////////////////////////////////////
//+------------------------------------------------------------------+//
//|                |//
//+------------------------------------------------------------------+//
////////////////////////////////////////////////////////////////////////
/*
     : 
     :
 double val_inp    //     ;
 double val_ref    //     ;
 double val_levtop //   ;
 double val_deltop //   ;
 double val_levbtm //   ;
 double val_delbtm //   ;
     :
 double comp_curr  //    ;
     : 
*/
double GetComparator(double val_inp,    double val_ref, 
                     double val_levtop, double val_deltop,
                     double val_levbtm, double val_delbtm)
 {
  static double comp_prev;        //     (+1, 0, -1)
  double comp_curr;                   //    
  double val_diff;   //       ()
 //----
  val_diff = val_inp - val_ref;
  if (val_diff > 0.)                               //  
   { 
    //        
    if ((val_diff >= (val_levbtm - val_delbtm)) && 
        (val_diff <= (val_levtop + val_deltop)))
     { 
      // ,     
      if (comp_prev < 0.)                              //   
       {
        comp_curr = 0.;        //      0
        comp_prev = comp_curr;            //   
        return(comp_curr);
       }
      else                                             //   
       {
        comp_curr = comp_prev;             //    
        return(comp_curr);
       }
     }
    //          
    if (val_diff > (val_levtop + val_deltop))
     {
      if (comp_prev <= 0.)           //   
       {
        //         
        comp_curr = 1.;        //      +1
        comp_prev = comp_curr;             //   
        return(comp_curr);
       }
      else                             //   
       {
        comp_curr = comp_prev;             //    
        return(comp_curr);
       }
     }
    //        
    if (val_diff < (val_levbtm - val_delbtm))
     {
      // ,     
      if (comp_prev < 0.)                              //   
       {
        comp_curr = 0.;        //      0
        comp_prev = comp_curr;            //   
        return(comp_curr);
       }
      if (comp_prev > 0.)              //   
       {
       //   ,      ,
       //    ;   
        comp_curr = 0.;         //      0
        comp_prev = comp_curr;             //   
        return(comp_curr);
       }
      else                           //   
       {
        comp_curr = comp_prev;             //    
        return(comp_curr);
       }
     }
   }
  else                                            //   
   {
    //        
    if ((val_diff >= -(val_levtop + val_deltop)) && 
        (val_diff <= -(val_levbtm - val_delbtm)))
     {
      // ,     
      if (comp_prev > 0.)                              //   
       {
        comp_curr = 0.;        //      0
        comp_prev = comp_curr;            //   
        return(comp_curr);
       }
      else                                             //   
       {
        comp_curr = comp_prev;             //    
        return(comp_curr);
       }
     }
    //        
    if (val_diff < -(val_levtop + val_deltop))
     {
      if (comp_prev >= 0.)           //   
       {
        //        
        comp_curr = -1.;      //      -1
        comp_prev = comp_curr;            //   
        return(comp_curr);
       }
      else                             //   
       {
        comp_curr = comp_prev;             //    
        return(comp_curr);
       }
     }
    //        
    if (val_diff > -(val_levbtm - val_delbtm))
     {
      // ,     
      if (comp_prev > 0.)                              //   
       {
        comp_curr = 0.;        //      0
        comp_prev = comp_curr;            //   
        return(comp_curr);
       }
      if (comp_prev < 0.)              //   
       {
        //   ,      ,
        //    ;   
        comp_curr = 0.;        //      0
        comp_prev = comp_curr;             //    
        return(comp_curr);
       }
      else                           //   
       {
        comp_curr = comp_prev;             //    
        return(comp_curr);
       }
     }
   }
 //----
 }